import numpy as np
from os import  path
import argparse

from x_input import loadInput, XInput


if __name__ == '__main__':


    parser = argparse.ArgumentParser()

    parser.add_argument('--letters', default=False, action='store_true')
    parser.add_argument('--split', default=False, action='store_true')

    parser.add_argument('--ism', default=False, action='store_true')
    parser.add_argument('--meme', default=False, action='store_true')



    x_in = loadInput(parser)
    output_file = path.join(x_in.resultFolder,x_in.out_file)
    lookup_file = path.join(x_in.resultFolder, x_in.out_file + 'ALPHABET')
    X = x_in.X



    u_values = np.unique(X)
    alph_id_mapping = dict(map(reversed,enumerate(u_values)))


    idX = map(lambda x: alph_id_mapping[x], X)

    selectedX = X if x_in.args.letters else idX
    linebreak = ' -2 \n' if x_in.args.ism else ' -1 '
    if x_in.args.meme: linebreak = ''
    letter = ' {} -1' if x_in.args.ism else '{} '


    output = ''

    if x_in.args.meme:
        output += '>SEQU1\n'

    for idx, y in zip(selectedX,x_in.Y):
        if y == 1 and x_in.args.split:
            output += linebreak
        output += letter.format(idx)
    output += linebreak

    if x_in.args.ism:
        output = output.replace('\n ','\n')
        output = output[1:]

    look_file = open(lookup_file, 'w+')
    for a, id in alph_id_mapping.items():
        look_file.write("{} \t {}\n".format(id,a))
    look_file.flush()
    look_file.close()

    out_file = open(output_file, 'w+')
    out_file.write(output)
    out_file.flush()
    out_file.close()