import copy
import math

from scipy.special import comb

from dst_length_helper import universal_interger_encoding

C = 2.865064


def length_frequ_strong(frequencies, seprateForNoPrediction = True):
    if seprateForNoPrediction:
        return length_frequ_seprate_strong(frequencies)
    else:
        return length_frequ_NonSeprate_strong(frequencies)



def length_frequ_NonSeprate_strong(frequencies):


    ub, lb, numberOfNonePredictions, sum_n = getRelevantValues(frequencies)
    nonEmpty = nonEmptyColumns(frequencies, lb, ub)

    length = 0
    length += universal_interger_encoding(ub, C)
    if ub != 0:
        length += math.log(ub,2)
    if numberOfNonePredictions != 0:
        nonEmpty +=1
    length += math.log(comb(ub+1, nonEmpty),2)
    if sum_n + numberOfNonePredictions != 0:
        length += math.log(comb(sum_n+numberOfNonePredictions -1, nonEmpty -1, exact=True),2)

    return length


def length_frequ_seprate_strong(frequencies):
    ub, lb, numberOfNonePredictions, sum_n = getRelevantValues(frequencies)
    nonEmpty = nonEmptyColumns(frequencies, lb, ub)

    length = 0
    length += universal_interger_encoding(ub + numberOfNonePredictions +1,C)
    k = nonEmpty + numberOfNonePredictions
    if ub + numberOfNonePredictions != 0:
        length += math.log(ub + numberOfNonePredictions,2)
        if k != 0:
            length += math.log(k,2)
    length += math.log(comb(ub+ numberOfNonePredictions, k),2)
    length += universal_interger_encoding(sum_n - nonEmpty +1,C)
    if k != 0:
        length += math.log(comb(sum_n + numberOfNonePredictions -1, k -1),2)

    return length

def nonEmptyColumns(frequencies, lb, ub):
    nonEmpty = 0
    for i in range(lb, ub+1):
        if i in frequencies.keys() and frequencies[i] != 0:
            nonEmpty += 1
    return nonEmpty


def getRelevantValues(frequencies):
    frequencies = copy.deepcopy(frequencies)
    # clean frequencies of 0 values etc. should not happen but just in case
    removeSet = set()
    for key in frequencies.keys():
        if frequencies[key] == 0:
            removeSet.add(key)
    for key in removeSet:
        frequencies.pop(key)
    try:
        numberOfNonePredictions = frequencies[None]
    except KeyError:
        numberOfNonePredictions = 0
    frequencies.pop(None, None)  # removes None key if present
    try:
        ub = max(frequencies.keys())
        lb = min(frequencies.keys())
    except ValueError:
        ub = 0
        lb = 0
    sum_n = sum(frequencies.values())
    return ub, lb, numberOfNonePredictions, sum_n


