import sys

import parseInput
from data_generation.gen_from_specification import parseJSONandGenerate


class XInput():
    def __init__(self, X, Y, result_folder, out_file, args, sample_results):
        self.X = X
        self.Y = Y
        self.resultFolder = result_folder
        self.out_file = out_file
        self.args = args
        self.sample_results = sample_results




def loadInput(parser, result=True):

    parser.add_argument('input_file', type=str)
    if result:
        parser.add_argument('result_folder', type=str)
    parser.add_argument('-o', type=str)

    args = parser.parse_args()

    if args.o == None:
        folders_file = args.input_file.split('/')
        just_file_name = folders_file[len(folders_file) - 1]
        output_file = 'sqs_input_-{}.dat'.format(just_file_name)
    else:
        output_file = args.o


    file_ending = args.input_file.split('.').pop()

    if file_ending == 'json':
        X, Y, specification = parseJSONandGenerate(args.input_file)
    elif file_ending == 'txt':
        X, Y, specification = parseInput.parseDirectDataInput(args.input_file)
    else:
        print('Invalid input file use .json for experiment specification')
        sys.exit()

    return XInput(X, Y, args.result_folder if result else None, output_file, args, (specification.planted_dst, specification.sampled_delta_sequ))